/*Copyright (C) 2010-2023 Duncan Deveaux

This file is part of Hikou no mizu.

Hikou no mizu is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Hikou no mizu is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Hikou no mizu.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef DEF_GAME_STATE_MESSAGE
#define DEF_GAME_STATE_MESSAGE

#include "Message.hpp"
#include "Network/Serialization/GameState.hpp"

class GameStateMessage : public Message
{
    public:
        GameStateMessage() = default;
        GameStateMessage(const GameState &gameState);

        bool fromBuffer(const Message::Buffer &buffer) override;
        Message::Buffer allocBuffer() const override;

        const GameState &getGameState() const;

    private:
        GameState m_gameState;
};

#endif
